﻿// CodeGear C++Builder
// Copyright (c) 1995, 2016 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'OverbyteIcsAvlTrees.pas' rev: 31.00 (Windows)

#ifndef OverbyteicsavltreesHPP
#define OverbyteicsavltreesHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member 
#pragma pack(push,8)
#include <System.hpp>
#include <SysInit.hpp>
#include <Winapi.Windows.hpp>
#include <System.SysUtils.hpp>
#include <System.Classes.hpp>
#include <System.SysConst.hpp>
#include <OverbyteIcsTypes.hpp>
#include <OverbyteIcsUtils.hpp>

//-- user supplied -----------------------------------------------------------

namespace Overbyteicsavltrees
{
//-- forward type declarations -----------------------------------------------
class DELPHICLASS TAvlTreeNode;
class DELPHICLASS TAvlTree;
class DELPHICLASS TSecIdxTree;
class DELPHICLASS TCacheTree;
class DELPHICLASS TCacheNode;
class DELPHICLASS TCacheIdxNode;
class DELPHICLASS TSecIdxDuplicates;
struct TIcsAvlPointerNode;
class DELPHICLASS TIcsAvlPointerTreeEnumerator;
class DELPHICLASS TIcsAvlPointerTree;
class DELPHICLASS TIcsAvlObjectTreeEnumerator;
class DELPHICLASS TIcsAvlObjectTree;
class DELPHICLASS TIcsThreadAvlPointerTree;
//-- type declarations -------------------------------------------------------
typedef int __fastcall (*TCompareFunction)(const System::UnicodeString S1, const System::UnicodeString S2);

typedef System::Int8 TBal;

#pragma pack(push,4)
class PASCALIMPLEMENTATION TAvlTreeNode : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	TBal Bal;
	TAvlTreeNode* Left;
	TAvlTreeNode* Right;
public:
	/* TObject.Create */ inline __fastcall TAvlTreeNode(void) : System::TObject() { }
	/* TObject.Destroy */ inline __fastcall virtual ~TAvlTreeNode(void) { }
	
};

#pragma pack(pop)

#pragma pack(push,4)
class PASCALIMPLEMENTATION TAvlTree : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	TAvlTreeNode* FFoundNode;
	TAvlTreeNode* FRoot;
	int FCount;
	virtual void __fastcall InternalSearchAndInsert(TAvlTreeNode* Node, TAvlTreeNode* &P, bool &HChange, bool &Found);
	
protected:
	void __fastcall DeleteNode(TAvlTreeNode* Node, TAvlTreeNode* &P, bool &HChange, bool &Ok);
	TAvlTreeNode* __fastcall SearchNode(TAvlTreeNode* Node, TAvlTreeNode* &P);
	virtual TAvlTreeNode* __fastcall SearchAndInsert(TAvlTreeNode* Node, bool &Found);
	void __fastcall BalanceLeft(TAvlTreeNode* &P, bool &HChange, bool DL);
	void __fastcall BalanceRight(TAvlTreeNode* &P, bool &HChange, bool DL);
	void __fastcall ListNodes(TAvlTreeNode* &P, bool &Cancel);
	virtual void __fastcall InternalClear(TAvlTreeNode* CurNode);
	virtual void __fastcall DoBeforeDelete(TAvlTreeNode* Node);
	virtual void __fastcall DoListNode(TAvlTreeNode* Node, bool &Cancel) = 0 ;
	virtual void __fastcall Clear(void);
	virtual int __fastcall Compare(TAvlTreeNode* Node1, TAvlTreeNode* Node2) = 0 ;
	virtual void __fastcall CopyNode(TAvlTreeNode* Source, TAvlTreeNode* Destination) = 0 ;
	
public:
	__fastcall virtual TAvlTree(void);
	__fastcall virtual ~TAvlTree(void);
	virtual bool __fastcall Remove(TAvlTreeNode* Node);
	TAvlTreeNode* __fastcall Search(TAvlTreeNode* Node);
	void __fastcall ListTree(void);
	TAvlTreeNode* __fastcall First(void);
	TAvlTreeNode* __fastcall Last(void);
	__property int Count = {read=FCount, nodefault};
	__property TAvlTreeNode* Root = {read=FRoot};
};

#pragma pack(pop)

#pragma pack(push,4)
class PASCALIMPLEMENTATION TSecIdxTree : public TAvlTree
{
	typedef TAvlTree inherited;
	
protected:
	virtual void __fastcall InternalClear(TAvlTreeNode* CurNode);
	virtual void __fastcall Clear(void);
	virtual void __fastcall DoListNode(TAvlTreeNode* Node, bool &Cancel);
	virtual int __fastcall Compare(TAvlTreeNode* Node1, TAvlTreeNode* Node2);
	virtual void __fastcall CopyNode(TAvlTreeNode* Source, TAvlTreeNode* Destination);
	
public:
	virtual bool __fastcall Remove(TAvlTreeNode* Node);
public:
	/* TAvlTree.Create */ inline __fastcall virtual TSecIdxTree(void) : TAvlTree() { }
	/* TAvlTree.Destroy */ inline __fastcall virtual ~TSecIdxTree(void) { }
	
};

#pragma pack(pop)

typedef void __fastcall (__closure *TCacheListEvent)(System::TObject* Sender, const System::UnicodeString Key, System::TDateTime TimeStamp, void * Data, int Len, System::TDateTime Expires, bool &Cancel);

typedef void __fastcall (__closure *TCacheFreeData)(System::TObject* Sender, void * Data, int Len);

class PASCALIMPLEMENTATION TCacheTree : public TAvlTree
{
	typedef TAvlTree inherited;
	
private:
	TSecIdxTree* FSecIdxTree;
	bool FCaseSensitive;
	TCacheFreeData FOnFreeData;
	TCacheListEvent FOnList;
	TCacheNode* FTmpNode;
	
protected:
	virtual void __fastcall DoBeforeDelete(TAvlTreeNode* Node);
	virtual void __fastcall DoListNode(TAvlTreeNode* Node, bool &Cancel);
	virtual int __fastcall Compare(TAvlTreeNode* Node1, TAvlTreeNode* Node2);
	virtual void __fastcall CopyNode(TAvlTreeNode* Source, TAvlTreeNode* Destination);
	virtual void __fastcall TriggerFreeData(void * Data, int Len);
	virtual void __fastcall InternalClear(TAvlTreeNode* CurNode);
	
public:
	__fastcall TCacheTree(bool CaseSensitive);
	__fastcall virtual ~TCacheTree(void);
	virtual void __fastcall Clear(void);
	void __fastcall Insert(System::UnicodeString Key, void * Data, int Len, System::TDateTime TimeStamp = -6.574340E+05, System::TDateTime Expires = -6.574340E+05, bool UpdateTime = true, bool UpdateData = true);
	void __fastcall Flush(System::TDateTime UpTo);
	virtual bool __fastcall Remove(TAvlTreeNode* Node);
	bool __fastcall RemoveKey(const System::UnicodeString Key);
	TCacheNode* __fastcall Oldest(void);
	TCacheNode* __fastcall FindKey(const System::UnicodeString AKey);
	__property TCacheFreeData OnFreeData = {read=FOnFreeData, write=FOnFreeData};
	__property TCacheListEvent OnList = {read=FOnList, write=FOnList};
};


#pragma pack(push,4)
class PASCALIMPLEMENTATION TCacheNode : public TAvlTreeNode
{
	typedef TAvlTreeNode inherited;
	
private:
	System::UnicodeString FKey;
	void *FData;
	int FLen;
	TCacheIdxNode* FIdxRef;
	
public:
	__fastcall TCacheNode(System::UnicodeString Key, void * Data, int Len);
	__fastcall virtual ~TCacheNode(void);
	__property System::UnicodeString Key = {read=FKey};
	__property void * Data = {read=FData, write=FData};
	__property int Len = {read=FLen, write=FLen, nodefault};
	__property TCacheIdxNode* IdxRef = {read=FIdxRef};
};

#pragma pack(pop)

class PASCALIMPLEMENTATION TCacheIdxNode : public TAvlTreeNode
{
	typedef TAvlTreeNode inherited;
	
private:
	TCacheNode* FCacheRef;
	System::TDateTime FTimeStamp;
	System::TDateTime FExpires;
	TSecIdxDuplicates* FDups;
	TCacheIdxNode* FNext;
	TCacheIdxNode* FPrev;
	
public:
	__fastcall TCacheIdxNode(TCacheNode* ACacheRef, System::TDateTime ATimeStamp, System::TDateTime AExpires);
	__fastcall virtual ~TCacheIdxNode(void);
	__property System::TDateTime TimeStamp = {read=FTimeStamp};
	__property System::TDateTime Expires = {read=FExpires};
};


#pragma pack(push,4)
class PASCALIMPLEMENTATION TSecIdxDuplicates : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	TCacheIdxNode* FLast;
	TCacheIdxNode* FFirst;
	
public:
	__fastcall virtual TSecIdxDuplicates(void);
	void __fastcall Clear(void);
	void __fastcall InsertAfter(TCacheIdxNode* ANode, TCacheIdxNode* NewNode);
	void __fastcall InsertBefore(TCacheIdxNode* ANode, TCacheIdxNode* NewNode);
	void __fastcall InsertTop(TCacheIdxNode* NewNode);
	void __fastcall InsertEnd(TCacheIdxNode* NewNode);
	void __fastcall Remove(TCacheIdxNode* ANode);
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TSecIdxDuplicates(void) { }
	
};

#pragma pack(pop)

typedef TIcsAvlPointerNode *PIcsAvlPointerNode;

struct DECLSPEC_DRECORD TIcsAvlPointerNode
{
public:
	void *Data;
	int Bal;
	TIcsAvlPointerNode *Up;
	System::StaticArray<PIcsAvlPointerNode, 2> Link;
};


enum DECLSPEC_DENUM TAvlIteratorDirection : unsigned char { aidFromBeginning, aidFromEnd };

#pragma pack(push,4)
class PASCALIMPLEMENTATION TIcsAvlPointerTreeEnumerator : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	TIcsAvlPointerTree* FTree;
	void *FOldCurrent;
	
public:
	__fastcall TIcsAvlPointerTreeEnumerator(TIcsAvlPointerTree* ATree);
	__fastcall virtual ~TIcsAvlPointerTreeEnumerator(void);
	void * __fastcall GetCurrent(void);
	bool __fastcall MoveNext(void);
	__property void * Current = {read=GetCurrent};
};

#pragma pack(pop)

enum DECLSPEC_DENUM TIcsAvlTreeNotification : unsigned char { atnAdded, atnRemoved };

#pragma pack(push,4)
class PASCALIMPLEMENTATION TIcsAvlPointerTree : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	TIcsAvlPointerNode *FRoot;
	int FCount;
	bool FAllowDups;
	TIcsAvlPointerNode *FCurrent;
	TAvlIteratorDirection FIteratorDir;
	PIcsAvlPointerNode __fastcall MakeNode(void * NodeData);
	PIcsAvlPointerNode __fastcall RotateSingleUB(PIcsAvlPointerNode Root, bool Dir);
	PIcsAvlPointerNode __fastcall RotateDoubleUB(PIcsAvlPointerNode Root, bool Dir);
	
protected:
	virtual bool __fastcall CompareData(void * Data1, void * Data2);
	virtual bool __fastcall SameData(void * Data1, void * Data2);
	virtual void __fastcall Notification(void * Data, TIcsAvlTreeNotification Action);
	PIcsAvlPointerNode __fastcall SearchNode(void * Data);
	PIcsAvlPointerNode __fastcall GetNextNode(PIcsAvlPointerNode From);
	PIcsAvlPointerNode __fastcall GetPrevNode(PIcsAvlPointerNode From);
	PIcsAvlPointerNode __fastcall GetFirstNode(void);
	PIcsAvlPointerNode __fastcall GetLastNode(void);
	__property PIcsAvlPointerNode Root = {read=FRoot};
	
public:
	__fastcall TIcsAvlPointerTree(bool AllowDups);
	__fastcall virtual ~TIcsAvlPointerTree(void);
	void __fastcall Clear(void);
	bool __fastcall Add(void * Data);
	bool __fastcall Remove(void * Data);
	bool __fastcall Contains(void * Data);
	void * __fastcall Find(void * Data, bool &Found);
	void * __fastcall Last(void);
	void * __fastcall First(void);
	TIcsAvlPointerTreeEnumerator* __fastcall GetEnumerator(void);
	bool __fastcall MoveNext(void);
	bool __fastcall SetCurrent(void * Data);
	void * __fastcall GetCurrent(void);
	void __fastcall ClearCurrent(void);
	__property TAvlIteratorDirection IteratorDirection = {read=FIteratorDir, write=FIteratorDir, nodefault};
	__property int Count = {read=FCount, nodefault};
};

#pragma pack(pop)

#pragma pack(push,4)
class PASCALIMPLEMENTATION TIcsAvlObjectTreeEnumerator : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	TIcsAvlPointerTree* FTree;
	void *FOldCurrent;
	
public:
	__fastcall TIcsAvlObjectTreeEnumerator(TIcsAvlObjectTree* ATree);
	__fastcall virtual ~TIcsAvlObjectTreeEnumerator(void);
	System::TObject* __fastcall GetCurrent(void);
	bool __fastcall MoveNext(void);
	__property System::TObject* Current = {read=GetCurrent};
};

#pragma pack(pop)

#pragma pack(push,4)
class PASCALIMPLEMENTATION TIcsAvlObjectTree : public TIcsAvlPointerTree
{
	typedef TIcsAvlPointerTree inherited;
	
private:
	bool FOwnsObjects;
	
protected:
	virtual void __fastcall Notification(void * Data, TIcsAvlTreeNotification Action);
	
public:
	__fastcall TIcsAvlObjectTree(bool AOwnsObjects, bool AllowDups);
	HIDESBASE bool __fastcall Add(System::TObject* Data);
	HIDESBASE bool __fastcall Remove(System::TObject* Data);
	HIDESBASE bool __fastcall Contains(System::TObject* Data);
	HIDESBASE System::TObject* __fastcall Find(System::TObject* Data, bool &Found);
	HIDESBASE System::TObject* __fastcall Last(void);
	HIDESBASE System::TObject* __fastcall First(void);
	HIDESBASE TIcsAvlObjectTreeEnumerator* __fastcall GetEnumerator(void);
	HIDESBASE bool __fastcall SetCurrent(System::TObject* Data);
	HIDESBASE System::TObject* __fastcall GetCurrent(void);
public:
	/* TIcsAvlPointerTree.Destroy */ inline __fastcall virtual ~TIcsAvlObjectTree(void) { }
	
};

#pragma pack(pop)

#pragma pack(push,4)
class PASCALIMPLEMENTATION TIcsThreadAvlPointerTree : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	TIcsAvlPointerTree* FTree;
	Overbyteicsutils::TIcsCriticalSection* FLock;
	
public:
	__fastcall TIcsThreadAvlPointerTree(void);
	__fastcall virtual ~TIcsThreadAvlPointerTree(void);
	bool __fastcall Add(void * Item);
	void __fastcall Clear(void);
	TIcsAvlPointerTree* __fastcall LockTree(void);
	void __fastcall UnlockTree(void);
	bool __fastcall Remove(void * Item);
};

#pragma pack(pop)

//-- var, const, procedure ---------------------------------------------------
#define MinDT  (-6.574340E+05)
}	/* namespace Overbyteicsavltrees */
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE) && !defined(NO_USING_NAMESPACE_OVERBYTEICSAVLTREES)
using namespace Overbyteicsavltrees;
#endif
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// OverbyteicsavltreesHPP
