﻿// CodeGear C++Builder
// Copyright (c) 1995, 2016 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'OverbyteIcsBlacklist.pas' rev: 31.00 (Windows)

#ifndef OverbyteicsblacklistHPP
#define OverbyteicsblacklistHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member 
#pragma pack(push,8)
#include <System.hpp>
#include <SysInit.hpp>
#include <Winapi.Messages.hpp>
#include <Winapi.Windows.hpp>
#include <System.Classes.hpp>
#include <System.SysUtils.hpp>
#include <System.DateUtils.hpp>
#include <OverbyteIcsWndControl.hpp>
#include <OverbyteIcsTypes.hpp>
#include <OverbyteIcsTicks64.hpp>
#include <OverbyteIcsUtils.hpp>

//-- user supplied -----------------------------------------------------------

namespace Overbyteicsblacklist
{
//-- forward type declarations -----------------------------------------------
struct TBlackRec;
struct TWhiteRec;
class DELPHICLASS TIcsBlacklist;
class DELPHICLASS TIcsBuffLogStream;
//-- type declarations -------------------------------------------------------
struct DECLSPEC_DRECORD TBlackRec
{
public:
	unsigned Addr;
	unsigned Mask;
	System::UnicodeString Value;
	bool Ascii;
	__int64 FirstUtime;
	__int64 LastUtime;
	int Attempts;
	int ReasonId;
	bool BlockedFlag;
};


typedef TBlackRec *PTBlackRec;

struct DECLSPEC_DRECORD TWhiteRec
{
public:
	unsigned Addr;
	unsigned Mask;
	System::UnicodeString Value;
};


typedef void __fastcall (__closure *TBlackLogEvent)(const System::UnicodeString info);

class PASCALIMPLEMENTATION TIcsBlacklist : public Overbyteicswndcontrol::TIcsWndControl
{
	typedef Overbyteicswndcontrol::TIcsWndControl inherited;
	
	
private:
	typedef System::DynamicArray<TBlackRec> _TIcsBlacklist__1;
	
	typedef System::DynamicArray<TWhiteRec> _TIcsBlacklist__2;
	
	
protected:
	_TIcsBlacklist__1 fBlackRecs;
	Overbyteicsutils::TIcsFindList* fBlackIdx;
	int fTotBlackRecs;
	_TIcsBlacklist__2 fWhiteRecs;
	Overbyteicsutils::TIcsFindList* fWhiteIdx;
	int fTotWhiteRecs;
	System::UnicodeString fBlackFile;
	System::UnicodeString fWhiteFile;
	Overbyteicswndcontrol::TIcsTimer* fTimer;
	bool fChangedFlag;
	int fFlushMins;
	int fCleanMins;
	__int64 fFlushTrg;
	__int64 fCleanTrg;
	int fBlockAfterMins;
	int fBlockAttempts;
	int fBlockForMins;
	bool fSaveAscii;
	System::UnicodeString fListName;
	TBlackLogEvent fBlackLogEvent;
	void __fastcall SetFlushMins(int Value);
	void __fastcall SetCleanMins(int Value);
	void __fastcall SetBlackFile(System::UnicodeString Value);
	void __fastcall OnTimer(System::TObject* Sender);
	int __fastcall ResizeArray(int NewLen);
	
public:
	__fastcall virtual TIcsBlacklist(System::Classes::TComponent* Aowner);
	__fastcall virtual ~TIcsBlacklist(void);
	void __fastcall doLogEvent(const System::UnicodeString info);
	void __fastcall FlushToFiles(void);
	void __fastcall LoadFromFiles(void);
	void __fastcall ClearList(void);
	void __fastcall CleanList(void);
	void __fastcall RebuildList(void);
	void __fastcall AddBlackList(const System::UnicodeString IpAddr, const System::UnicodeString IpMask, int ReasonId);
	void __fastcall AddWhiteList(const System::UnicodeString IpAddr, const System::UnicodeString IpMask);
	void __fastcall RemBlackList(const System::UnicodeString IpAddr);
	void __fastcall RemWhiteList(const System::UnicodeString IpAddr);
	bool __fastcall CheckBlackList(const System::UnicodeString IpAddr);
	TBlackRec __fastcall GetFullBlackList(const System::UnicodeString IpAddr);
	bool __fastcall FailedBlackList(const System::UnicodeString IpAddr, int ReasonId);
	TBlackRec __fastcall InternalAddBlack(const System::UnicodeString IpAddr, const System::UnicodeString IpMask, bool MoreAttempts, int ReasonId);
	System::UnicodeString __fastcall ReportBlackList(bool All);
	int __fastcall GetCountAll(void);
	int __fastcall GetCountBlock(void);
	
__published:
	__property bool SaveAscii = {read=fSaveAscii, write=fSaveAscii, nodefault};
	__property System::UnicodeString ListName = {read=fListName, write=fListName};
	__property System::UnicodeString BlackFile = {read=fBlackFile, write=SetBlackFile};
	__property System::UnicodeString WhiteFile = {read=fWhiteFile, write=fWhiteFile};
	__property int FlushMins = {read=fFlushMins, write=SetFlushMins, nodefault};
	__property int CleanMins = {read=fCleanMins, write=SetCleanMins, nodefault};
	__property int BlockAfterMins = {read=fBlockAfterMins, write=fBlockAfterMins, nodefault};
	__property int BlockAttempts = {read=fBlockAttempts, write=fBlockAttempts, nodefault};
	__property int BlockForMins = {read=fBlockForMins, write=fBlockForMins, nodefault};
	__property TBlackLogEvent BlackLogEvent = {read=fBlackLogEvent, write=fBlackLogEvent};
};


enum DECLSPEC_DENUM TFileCodePage : unsigned char { FileCPAnsi, FileCPUtf8, FileCPUtf16 };

class PASCALIMPLEMENTATION TIcsBuffLogStream : public Overbyteicswndcontrol::TIcsWndControl
{
	typedef Overbyteicswndcontrol::TIcsWndControl inherited;
	
private:
	Overbyteicsutils::TIcsStringBuild* FBuffer;
	int FIdleSecs;
	Overbyteicswndcontrol::TIcsTimer* FIdleTimer;
	System::UnicodeString FHeader;
	int FBuffMax;
	System::UnicodeString FNameMask;
	int FLogSize;
	System::UnicodeString FFullName;
	int FOpenAttempts;
	unsigned FOpenDelayMs;
	TFileCodePage FFileCP;
	
protected:
	void __fastcall OnTimer(System::TObject* Sender);
	void __fastcall SetIdleSecs(int IdleSecs);
	void __fastcall SetNameMask(System::UnicodeString sNameMask);
	void __fastcall SetFileCP(TFileCodePage sFileCP);
	
public:
	__fastcall TIcsBuffLogStream(System::Classes::TComponent* Aowner, const System::UnicodeString sNameMask, const System::UnicodeString sHeader, TFileCodePage sFileCP);
	__fastcall virtual ~TIcsBuffLogStream(void);
	int __fastcall FlushFile(bool OldFName = false);
	int __fastcall WriteLine(const System::UnicodeString Line, bool AddCRLF = true);
	__property int BuffMax = {read=FBuffMax, write=FBuffMax, nodefault};
	__property System::UnicodeString Header = {read=FHeader, write=FHeader};
	__property int IdleSecs = {read=FIdleSecs, write=SetIdleSecs, nodefault};
	__property System::UnicodeString NameMask = {read=FNameMask, write=SetNameMask};
	__property TFileCodePage FileCP = {read=FFileCP, write=SetFileCP, nodefault};
	__property int OpenAttempts = {read=FOpenAttempts, write=FOpenAttempts, nodefault};
	__property unsigned OpenDelayMs = {read=FOpenDelayMs, write=FOpenDelayMs, nodefault};
	__property int LogSize = {read=FLogSize, nodefault};
	__property System::UnicodeString FullName = {read=FFullName};
};


//-- var, const, procedure ---------------------------------------------------
extern DELPHI_PACKAGE System::UnicodeString CopyRight;
#define OneMask L"255.255.255.255"
extern DELPHI_PACKAGE System::ResourceString _SFBuffOpenError;
#define Overbyteicsblacklist_SFBuffOpenError System::LoadResourceString(&Overbyteicsblacklist::_SFBuffOpenError)
extern DELPHI_PACKAGE void __fastcall IcsSimpleLogging(const System::UnicodeString FNameMask, const System::UnicodeString Msg);
}	/* namespace Overbyteicsblacklist */
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE) && !defined(NO_USING_NAMESPACE_OVERBYTEICSBLACKLIST)
using namespace Overbyteicsblacklist;
#endif
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// OverbyteicsblacklistHPP
