﻿// CodeGear C++Builder
// Copyright (c) 1995, 2016 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'OverbyteIcsSntp.pas' rev: 31.00 (Windows)

#ifndef OverbyteicssntpHPP
#define OverbyteicssntpHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member 
#pragma pack(push,8)
#include <System.hpp>
#include <SysInit.hpp>
#include <Winapi.Messages.hpp>
#include <Winapi.Windows.hpp>
#include <OverbyteIcsWinsock.hpp>
#include <System.Classes.hpp>
#include <System.SysUtils.hpp>
#include <System.DateUtils.hpp>
#include <OverbyteIcsWndControl.hpp>
#include <OverbyteIcsWSocket.hpp>
#include <OverbyteIcsUtils.hpp>

//-- user supplied -----------------------------------------------------------

namespace Overbyteicssntp
{
//-- forward type declarations -----------------------------------------------
class DELPHICLASS TIcsTimeServer;
struct TNtpTime;
struct SNTPheader;
class DELPHICLASS TIcsTimeClient;
//-- type declarations -------------------------------------------------------
enum DECLSPEC_DENUM TTimeProtocol : unsigned char { tpSNTP, tpTCP, tpUDP, tpRoughTime };

typedef System::Set<TTimeProtocol, TTimeProtocol::tpSNTP, TTimeProtocol::tpRoughTime> TTimeProtoSet;

typedef void __fastcall (__closure *TTimeQuery)(System::TObject* Sender, const sockaddr_in &SocketAddr, TTimeProtocol TimeProtocol, bool &Continue);

typedef void __fastcall (__closure *TTimeQueryDone)(System::TObject* Sender, System::Word Error);

class PASCALIMPLEMENTATION TIcsTimeServer : public System::Classes::TComponent
{
	typedef System::Classes::TComponent inherited;
	
public:
	sockaddr_in SrcIPAddr;
	__fastcall virtual TIcsTimeServer(System::Classes::TComponent* AOwner);
	__fastcall virtual ~TIcsTimeServer(void);
	void __fastcall Start(void);
	void __fastcall Stop(void);
	
protected:
	System::UnicodeString FAddrStr;
	Overbyteicswsocket::TWSocket* FWUDPSocket;
	Overbyteicswsocket::TWSocket* FWTCPSocket;
	Overbyteicswsocket::TWSocket* FWSNTPSocket;
	Overbyteicswsocket::TWSocket* FClientSocket;
	Overbyteicswsocket::TSessionConnected FOnSessionConnected;
	Overbyteicswsocket::TSessionClosed FOnSessionClosed;
	TTimeQuery FOnQuery;
	TTimeQueryDone FOnQueryDone;
	TTimeProtoSet FTimeProtocol;
	bool FRunning;
	System::Classes::TNotifyEvent FOnStart;
	System::Classes::TNotifyEvent FOnStop;
	void __fastcall WUDPSocketSessionConnected(System::TObject* Sender, System::Word Error);
	void __fastcall WUDPSocketDataAvailable(System::TObject* Sender, System::Word Error);
	void __fastcall WUDPSocketSessionClosed(System::TObject* Sender, System::Word Error);
	void __fastcall WSNTPSocketSessionConnected(System::TObject* Sender, System::Word Error);
	void __fastcall WSNTPSocketDataAvailable(System::TObject* Sender, System::Word Error);
	void __fastcall WSNTPSocketSessionClosed(System::TObject* Sender, System::Word Error);
	void __fastcall ClientOnDataSent(System::TObject* Sender, System::Word Error);
	void __fastcall TriggerQueryDone(System::Word Error);
	void __fastcall TriggerServerStart(void);
	void __fastcall TriggerServerStop(void);
	void __fastcall WTCPSocketSessionAvailable(System::TObject* Sender, System::Word Error);
	void __fastcall CreateUDPSocket(void);
	void __fastcall CreateSNTPSocket(void);
	void __fastcall CreateTCPSocket(void);
	void __fastcall StartTCPServer(void);
	void __fastcall StartUDPServer(void);
	void __fastcall StartSNTPServer(void);
	
__published:
	__property System::UnicodeString Addr = {read=FAddrStr, write=FAddrStr};
	__property TTimeProtoSet TimeProtocol = {read=FTimeProtocol, write=FTimeProtocol, nodefault};
	__property System::Classes::TNotifyEvent OnStop = {read=FOnStop, write=FOnStop};
	__property System::Classes::TNotifyEvent OnStart = {read=FOnStart, write=FOnStart};
	__property Overbyteicswsocket::TSessionConnected OnSessionConnected = {read=FOnSessionConnected, write=FOnSessionConnected};
	__property Overbyteicswsocket::TSessionClosed OnSessionClosed = {read=FOnSessionClosed, write=FOnSessionClosed};
	__property TTimeQueryDone OnQueryDone = {read=FOnQueryDone, write=FOnQueryDone};
	__property TTimeQuery OnQuery = {read=FOnQuery, write=FOnQuery};
	__property bool IsRunning = {read=FRunning, nodefault};
};


typedef void __fastcall (__closure *TTimeEvent)(System::TObject* Sender, System::TDateTime DateTime);

typedef void __fastcall (__closure *TTimeInfoEvent)(System::TObject* Sender, System::UnicodeString Info);

#pragma pack(push,1)
struct DECLSPEC_DRECORD TNtpTime
{
public:
	unsigned Seconds;
	unsigned FracSecs;
};
#pragma pack(pop)


#pragma pack(push,1)
struct DECLSPEC_DRECORD SNTPheader
{
public:
	System::Byte LIvnMmode;
	System::Byte Statum;
	System::Byte Poll;
	System::Int8 Precision;
	int RootDelay;
	int RootDispersion;
	unsigned RefIdent;
	TNtpTime RefTimeStamp;
	TNtpTime OrigTimeStamp;
	TNtpTime RecvTimeStamp;
	TNtpTime XmitTimeStamp;
};
#pragma pack(pop)


class PASCALIMPLEMENTATION TIcsTimeClient : public System::Classes::TComponent
{
	typedef System::Classes::TComponent inherited;
	
private:
	Overbyteicswsocket::TWSocket* FWSocket;
	System::UnicodeString FServerAddr;
	Overbyteicswsocket::TSocketFamily FSocketFamily;
	int FTimeoutSecs;
	TTimeEvent FOnTime;
	TTimeInfoEvent FOnTimeInfo;
	TTimeProtocol FTimeProtocol;
	Overbyteicswndcontrol::TIcsTimer* FTimeoutTimer;
	int FCurrDnsResult;
	int FTotDnsResult;
	int FAttempts;
	System::UnicodeString FLastAddrOK;
	System::UnicodeString FLastProgress;
	
protected:
	void __fastcall WSocketSessionConnected(System::TObject* Sender, System::Word Error);
	void __fastcall TimeDataAvailable(System::TObject* Sender, System::Word Error);
	void __fastcall DnsLookupDone(System::TObject* Sender, System::Word ErrCode);
	void __fastcall TimeoutTimerTimer(System::TObject* Sender);
	void __fastcall DoProgress(const System::UnicodeString S);
	bool __fastcall StartTime(void);
	
public:
	SNTPheader SNTP;
	System::TDateTime DTRequest;
	System::TDateTime DTOriginate;
	System::TDateTime DTReceive;
	System::TDateTime DTTransmit;
	System::TDateTime DTDestination;
	System::TDateTime DTRoundtrip;
	int MSecsRoundtrip;
	System::TDateTime DTDifference;
	double SecsDifference;
	System::UnicodeString SecsDiffDisp;
	int Tag2;
	int ServLI;
	int ServVN;
	int ServMode;
	__fastcall virtual TIcsTimeClient(System::Classes::TComponent* AComponent);
	__fastcall virtual ~TIcsTimeClient(void);
	bool __fastcall GetTime(void);
	System::UnicodeString __fastcall GetIpAddr(void);
	void __fastcall Abort(void);
	__property System::UnicodeString IpAddress = {read=GetIpAddr};
	__property int Attempts = {read=FAttempts, nodefault};
	__property System::UnicodeString LastProgress = {read=FLastProgress};
	
__published:
	__property System::UnicodeString ServerAddr = {read=FServerAddr, write=FServerAddr};
	__property Overbyteicswsocket::TSocketFamily SocketFamily = {read=FSocketFamily, write=FSocketFamily, nodefault};
	__property TTimeProtocol TimeProtocol = {read=FTimeProtocol, write=FTimeProtocol, nodefault};
	__property int TimeoutSecs = {read=FTimeoutSecs, write=FTimeoutSecs, nodefault};
	__property TTimeEvent OnTime = {read=FOnTime, write=FOnTime};
	__property TTimeInfoEvent OnTimeInfo = {read=FOnTimeInfo, write=FOnTimeInfo};
};


//-- var, const, procedure ---------------------------------------------------
extern DELPHI_PACKAGE System::UnicodeString CopyRight;
extern DELPHI_PACKAGE System::UnicodeString __fastcall IcsDateTimeZZtoStr(System::TDateTime DT);
extern DELPHI_PACKAGE TNtpTime __fastcall IcsGetUTCNtpTime(void);
extern DELPHI_PACKAGE double __fastcall IcsTimeToFSecs(System::TDateTime DT);
extern DELPHI_PACKAGE System::TDateTime __fastcall IcsConvTimeStamp(unsigned timestamp);
extern DELPHI_PACKAGE System::TDateTime __fastcall IcsNtp2TDateTime(const TNtpTime &NtpTime);
}	/* namespace Overbyteicssntp */
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE) && !defined(NO_USING_NAMESPACE_OVERBYTEICSSNTP)
using namespace Overbyteicssntp;
#endif
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// OverbyteicssntpHPP
